
///    (Brenkman Andrey)
///   5.09.2011
///    99%

#ifndef LIST_H
#define LIST_H

#include "linux-compat.h"

//!
#include "constants_header.h"

/*
Move List

*/


///   . ..         .
struct List
{
	///     move     ( 27 )
	/// --3 --      --6 --   --6 --     --6 --  --6 -- 
	///               

	///-----------------------------------------------
	///   ..   
	/// --6 -- 
	///  

	/// 0 -  
	/// 1 -  
	/// 2 -  
	/// 3 - 
	/// 4 -  
	/// 5 -  
	/// 6 - 

	///  move =  
	///  move & 63 ( 63  ...000111111)

	///-------------------------------------------------
	/// --6 --
	///  

	/// 0 -  
	/// 1   
	/// 2  
	/// 3   
	/// 4   
	/// 5    

	/// 12 -    
	/// 13 -   
	/// 14 -    
	/// 15 -    

	/// 22 -      
	/// 23 -     
	/// 24 -      
	/// 25 -      
 
	///  move = move | (  << 6)
	///  (move>>6) & 63

	///-------------------------------------------------
	/// --6 --
	///   (0 -63)
	///  move = move | (  << 12)
	///  (move>>12) & 63

	///-------------------------------------------------
	/// --6 --
	///   (0 -63)
	///  move = move | (  << 18)
	///  (move>>18) & 63

	///-------------------------------------------------
	/// --3 -- 
	///  
	/// 0 -  
	/// 1 -  
	/// 2 -  
	/// 3 - 
	/// 4 -  
	/// 5 -  
	/// 6 - 
	///  move = move | (  << 24)
	///  (move>>24) & 7 ( 7  ...000111)

	int32_t move[MAX_MOVE];

	///     
	int32_t sorting_score[MAX_MOVE];

	///         .   
	/// (       )
	uint8_t end_captures;

	///       ..  
	uint8_t end_list;

};

#endif // !defined LIST_H






