
///    (Brenkman Andrey)
///   5.09.2011
///    99%


#ifndef POSITION_H
#define POSITION_H

#include "linux-compat.h"

//!
#include "constants_header.h"


///  64-    
struct Position
{
	///-------------------------------------------------
	///    
	/// A8(56) B8(57) C8(58) D8(59) E8(60) F8(61) G8(62) H8(63)
	/// A7(48) B7(49) C7(50) D7(51) E7(52) F7(53) G7(54) H7(55)
	/// A6(40) B6(41) C6(42) D6(43) E6(44) F6(45) G6(46) H6(47)
	/// A5(32) B5(33) C5(34) D5(35) E5(36) F5(37) G5(38) H5(39)
	/// A4(24) B4(25) C4(26) D4(27) E4(28) F4(29) G4(30) H4(31)
	/// A3(16) B3(17) C3(18) D3(19) E3(20) F3(21) G3(22) H3(23)
	/// A2(8)  B2(9)  C2(10) D2(11) E2(12) F2(13) G2(14) H2(15)
	/// A1(0)  B1(1)  C1(2)  D1(3)  E1(4)  F1(5)  G1(6)  H1(7)


	///A1(LSB)-    H8(MSB)- 63 
	/// ..     
	/// H8(63) G8(62) F8(61) . . . . . .C1(2) B1(1) A1(0)
	///-------------------------------------------------
	/// 
	///   64  
	///           
	///            
	///     
	uint64_t  all_piece;//  
	uint64_t  all_white_piece;//   
	uint64_t  all_black_piece;//   

	///-------------------------------------------------
	///  

	///  
	/// 0 -  
	/// 1 -  
	/// 2 -  
	/// 3 - 
	/// 4 -  
	/// 5 -  
	/// 6 - 
	
	///      
	///  64-           5() 
	///    64  
	uint64_t white_piece[MAX_NAME];
	uint64_t black_piece[MAX_NAME];

	///  (0-6)  (0-63) 
	uint8_t white_name_from_coord[MAX_COORDINATE];
	uint8_t black_name_from_coord[MAX_COORDINATE];

	///-------------------------------------------------
	///  

	///   0 -  1 - 
	bool colour_move;

	///     1/0
	bool taking_passage_yes;

	///    (  )
	///  '' - 0 , 'h' - 7      
	uint8_t taking_passage_x;

	///    
	///  '1' - 0 , '8' - 7     
	///     1
	uint8_t taking_passage_y;

	///        1/0
	bool castling_Q;

	///       1/0
	bool castling_K;

	///       1/0
	bool castling_q;

	///      1/0
	bool castling_k;

	/// 64  - 
	uint64_t hash_key ;

	///     	
	uint16_t value_white_material ;

	///     
	uint16_t value_black_material ;

};

#endif // !defined POSITION_H






