
///    (Brenkman Andrey)
///   22.02.2009 25.12.2010
///    50%

#include "linux-compat.h"

#include "position_struct.h"

/// -(1-0)      
#define TEST_D 0; 

/// -(1-0)   
///    
///     TEST_WRITE_READ  j_Hash.h
#define TEST_WRITE_READ_WN 0 
                             


///   go   

///    :
///     5   5  +     
/// > go btime 300000 wtime 300000 
/// for game in 5min. 

/// > go btime 302000 wtime 302000 winc 2000 binc 2000 
/// with incremental clock 5 min + 2 sec. 

///     
/// > go movestogo 40 wtime 300000 btime 300000 
/// for 40 moves in 5 min. 
///     
/// > go wtime 300000 btime 300000  movestogo 40

///     
/// > go infinite 
/// for analysing. 

///                
/// > go movetime 300000 
/// Exactly 5min for the next move, not supported by Fritz. 

///    
/// > go depth 5 

namespace Uci_go
{

///  
//////////////////////////////////////////////////////////////////////////////////////
//private:

//////////////////////////////////////////////////////////////////////////////////////
//public:

	///
	void parse_go
	(
		struct Position & position,//  
		const std::string string_in// 
	);

//////////////////////////////////////////////////////////////////////////////////////
//private:

	///     

	///           .
	/// ..     1  2  ..
	///       -
	///       .      
	///           .

	///     

	/// > go depth 5 
	///    
	///       depth_max  

	/// > go btime 300000 wtime 300000 
	/// for game in 5min. 
	/// > go btime 302000 wtime 302000 winc 2000 binc 2000 
	/// with incremental clock 5 min + 2 sec. 
	///     5   5  +     
	///      time_terminate  
	///     time_terminate = wtime/100;
	/// ..            .
	///             

	/// > go infinite
	///    infinite   depth_max  50. 
	///    
	///     quit  stop

	/// > go movetime 300000 
	///        time_terminate = movetime;


	/// > go movestogo 40 wtime 300000 btime 300000 
	/// for 40 moves in 5 min. 
	///     
	///       
	/// > go wtime 300000 btime 300000 
	///           

	///       

	///--------------------------------------------------------------------------
	void deepening
	(
		struct Position & position, ///  
		uint8_t & depth_max,
		double & max_time_move_search
	);


//////////////////////////////////////////////////////////////////////////////////////
//private:

	///--------------------------------------------------------------------------
	///   
	void ini_go_command
	(
		const std::string string_in// 
	);

	///--------------------------------------------------------------------------
	///    
	void ini_deepening
	(
		struct Position & position,//  
		uint8_t & depth_max,
		double & max_time_move_search
	);

	///--------------------------------------------------------------------------
	///     
	void test_ini_go_command();

	///--------------------------------------------------------------------------
	///
	void do_bestmove();

	///--------------------------------------------------------------------------
	///
	void print_deepening_line
	(
		struct Position & position,//  
		const int64_t nodes,//   ()
		const double time_current,  //      
		const uint8_t depth,
		const int32_t value_root,//      .
		bool & flag_mate//   
	);

	///--------------------------------------------------------------------------
	///
	void test_end_deepening
	(
		struct Position & position,//  
		const uint64_t key_control
	);

	///--------------------------------------------------------------------------
	///
	void test_loop
	(
		struct Position & position,//  
 		const int32_t test_eval,//     
		const uint64_t key_control//  -  
	);

};
